<?php
namespace Teknisa\CMP\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Exception;
use \Setforms2\Shared\ORM\DateTime;
use Teknisa\CMP\Services\ValidaFilialService;

class ValidaFilialController extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $newCode;
    protected $crudService;
    
    public function __construct($crudService, $parameterBag, ValidaFilialService $service, $environment, $newCode) {
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
		$this->service      = $service;
		$this->environment  = $environment;
		$this->newCode      = $newCode;
    }
    
    public function criaListaFilial(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            if(isset($row["P_CDOPERADOR"])) {
                $result = $this->service->retornaListaDeFiliais($row["P_CDOPERADOR"]);
                if(is_array($result)) {
                    $str = "_";
                    foreach($result as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $result = $str;
                }
            } else {
                throw new Exception("Não foi possível obter o código do operador!");
            }
            $response->addDataSet(new DataSet("res", array($result))); 
        } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 1));
        }
    }
}