<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\EmissaoAutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\DTO;

class Cmp04100BaixaAFs extends \Zeedhi\Framework\Controller\Report
{

    protected $qr2Strategy;

    public function __construct($reportService, $qr2Strategy)
    {
        $this->reportService    = $reportService;
        $this->qr2Strategy      = $qr2Strategy;
    }

    protected $reportMapping = array (
        'cmp04100' => 
            array (
                'strategy' => 'QR2',
                'parameterMapping' => 
                    array (
                        'CDPRODUTO'        => 'P_CDPRODini',
                        'CDPRODFINAL'      => 'P_CDPRODfin',
                        'LISTAFILIAIS'     => 'L_CDFILIAL',
                        'CDPRODINI'        => 'P_CDPRODini_DIG',
                        'CDPRODFIM'        => 'P_CDPRODfin_DIG',
                        'NMPRODUTO'        => 'P_NMPRODini',
                        'NMPRODFINAL'      => 'P_NMPRODfin',
                        'DTINICIAL'        => 'P_DTini',
                        'DTFINAL'          => 'P_DTfin',
                        'DATAINI'          => 'P_DTiniSTR',
                        'DATAFIN'          => 'P_DTfinSTR',
                        'P_MODO'           => 'P_MODO',
                        'P_IDBAIXAAF'      => 'P_IDBAIXAAF',
                        'P_IDBAIXAAF_NULL' => 'P_IDBAIXAAF_NULO',
                        'EXPIRADA'         => 'P_IDAFEXPIRADA',
                    ),
            ),
            
        'cmp04101' => 
            array (
                'strategy' => 'QR2',
                'parameterMapping' => 
                    array (
                        'CDPRODUTO'        => 'P_CDPRODini',
                        'CDPRODFINAL'      => 'P_CDPRODfin',
                        'LISTAFILIAIS'     => 'L_CDFILIAL',
                        'CDPRODINI'        => 'P_CDPRODini_DIG',
                        'CDPRODFIM'        => 'P_CDPRODfin_DIG',
                        'NMPRODUTO'        => 'P_NMPRODini',
                        'NMPRODFINAL'      => 'P_NMPRODfin',
                        'DTINICIAL'        => 'P_DTini',
                        'DTFINAL'          => 'P_DTfin',
                        'DATAINI'          => 'P_DTiniSTR',
                        'DATAFIN'          => 'P_DTfinSTR',
                        'P_MODO'           => 'P_MODO',
                        'P_IDBAIXAAF'      => 'P_IDBAIXAAF',
                        'P_IDBAIXAAF_NULL' => 'P_IDBAIXAAF_NULO',
                        'EXPIRADA'         => 'P_IDAFEXPIRADA',
                    ),
            ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);

        $row['P_MODO']      = 'N';
        $row['CDPRODFINAL'] = str_pad($row['CDPRODFINAL'], 10, 'Z', STR_PAD_RIGHT);
    }
}
