<?php
namespace Teknisa\CMP\Modules\Solicitacao\Modules\Relatorios\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class SolicitacaoComprasUnidadeController extends \Zeedhi\Framework\Controller\Report {
    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $stNomeRel;
    protected $filialService;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection, $filialService) {
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
        $this->filialService       = $filialService;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
        $row = $request->getRow();
        
        $cdOperador = $this->environment->getCdOperador();
        
        if($row["CDFILSOLI"] == "T") {
            $newFilial = $this->filialService->retornaListaDeFiliais($cdOperador);
            if(is_array($newFilial)) {
                    $str = "_";
                    foreach($newFilial as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $newFilial = $str;
                    $row["CDFILSOLI"] = $newFilial;
                }
        }
        
        if($row["CDFILSOLI1"] == "T") {
            $newFilial = $this->filialService->retornaListaDeFiliais($cdOperador);
            if(is_array($newFilial)) {
                    $str = "_";
                    foreach($newFilial as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $newFilial = $str;
                    $row["CDFILSOLI1"] = $newFilial;
                }
        }
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array (
            'strategy' => $row['STRATEGY'],
            'parameterMapping' =>
            array (
                "CDFILSOLI"     => "L_CDFILSOLI",        
                "CDFILSOLI1"    => "L_CDFILSOLI1",
                "REGIAO"        => "L_REGIAO",
                "REGIAO1"       => "L_REGIAO1",
                "GROUPFIL"      => "L_FILGRUPFILI",
                "GROUPFIL1"     => "L_FILGRUPFILI1",
                "CDFILLANC"     => "L_CDFILLANC",
                "CDFILLANC1"    => "L_CDFILLANC1",
                "SOL"           => "L_NRSOLI",
                "SOL1"          => "L_NRSOLI1",
                "DTINI"         => "P_DTINI",
                "DTFIM"         => "P_DTFIM",
                "DTINI1"        => "P_TDTINI",
                "DTFIM1"        => "P_TDTFIM",
                "IMPRIME"       => "P_IMPRIMEOBS",
                "PRODINI"       => "P_PRODINI",
                "PRODFIN"       => "P_PRODFIN",
                "NMTIPOCUSTO"   => "P_NRTIPOCUSTO"
             ),
        );
    }
}
