function NecessidadeCompraService(restEngine) {
    this.excluiNecessidadeCompra = function(rowsNecessidade, nomeWidget) {
        return restEngine.post('\/excluiNecessidadeCompra', {
            "requestType": "Row",
            "row": {
                "rowsNecessidade": rowsNecessidade,
                "nomeWidget": nomeWidget
            }
        });
    };

    this.excluiTrabnececomp = function(nrnececomp, nrorg) {
        return restEngine.post('\/excluiTrabnececomp', {
            "requestType": "Row",
            "row": {
                "nrnececomp": nrnececomp,
                "nrorg": nrorg
            }
        });
    };

    this.proceCalculaPrevconsFiliais = function(paramProcedure) {
        return restEngine.post('\/proceCalculaPrevconsFiliais', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.procePeriodicidadeNaoCalculada = function(paramProcedure) {
        return restEngine.post('\/procePeriodicidadeNaoCalculada', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.proceNecessidadeDeCompras = function(paramProcedure) {
        return restEngine.post('\/proceNecessidadeDeCompras', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.proceGeraSolicitacao = function(paramProcedure) {
        return restEngine.post('\/proceGeraSolicitacao', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.dataPrevisaoConsumo = function(params){
        return restEngine.post('\/dataPrevisaoConsumo', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRORG", "value": params.NRORG, "operator": "="},
                {"name": "CDFILIAL", "value": params.CDFILIAL, "operator": "="},
                {"name": "CDGRUPFILI", "value": params.CDGRUPFILI, "operator": "="},
                {"name": "CDPRODUTOINI", "value": params.CDPRODINI, "operator": "="},
                {"name": "CDPRODUTOFIN", "value": params.CDPRODFIN, "operator": "="}
            ]
        });
    };

    this.listaUnidades = function(nrnececomp, nrorg){
        return restEngine.post('\/trabnececompDistinct', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRNECECOMP", "value": nrnececomp, "operator": "="},
                {"name": "NRORG", "value": nrorg, "operator": "="}
            ]
        });
    };

    this.openReportSemMensagem = function(route, reportName, params) {
        params.__report_name = reportName;
        params.QR2TYPE = 'pdf';
        return restEngine.post(route, {
            "requestType": "Row",
            "row": params
        }, null, null, null, null, 30000).then(function(response) {
            if (response && response.messages) {
                var report = response.messages.pop();
                window.open(report.message);
            }
        }).catch(function(response) {
            if (response.data && response.data.error) {
                console.log(response.data.error);
            }
        });
    };

}

Configuration(function(ContextRegister) {
	ContextRegister.register('NecessidadeCompraService', NecessidadeCompraService);
});